//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

TColor Colors[18]={clAqua,clBlue ,clDkGray,clFuchsia,clGray,clGreen,clLime,clLtGray,clMaroon ,clNavy,clOlive,clPurple,clRed,clSilver,clTeal ,clYellow,clWhite};
unsigned short RegionColor[300] ;
AnsiString RegionName[300] ;

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ComboBox1DrawItem(TWinControl *Control, int Index,
      TRect &Rect, TOwnerDrawState State)
{

((TComboBox *)Control)->Canvas->Brush->Color = Colors[Index];
((TComboBox *)Control)->Canvas->Brush->Style = bsSolid;
((TComboBox *)Control)->Canvas->FillRect(Classes::Rect(Rect.Left+2, Rect.Top+2, Rect.Left+14, Rect.Bottom-2)); //ҥHClasses::RectO]?PѼƭW
((TComboBox *)Control)->Canvas->Pen->Color = clBlack;
((TComboBox *)Control)->Canvas->Rectangle(Rect.Left+1, Rect.Top+1, Rect.Left+15, Rect.Bottom-1);

((TComboBox *)Control)->Canvas->Font->Color = clBlack;
((TComboBox *)Control)->Canvas->Font->Size = 9;

((TComboBox *)Control)->Canvas->Brush->Style = bsClear;
((TComboBox *)Control)->Canvas->TextOut(Rect.Left+20, Rect.Top+2, ColorToString(Colors[Index]));

if(State.Contains(odFocused))
{
((TComboBox *)Control)->Canvas->Pen->Color = clBlue;
((TComboBox *)Control)->Canvas->Rectangle(Rect.Left, Rect.Top, Rect.Right, Rect.Bottom);
}
else
{
((TComboBox *)Control)->Canvas->Pen->Color = clWhite;
((TComboBox *)Control)->Canvas->Rectangle(Rect.Left, Rect.Top, Rect.Right, Rect.Bottom);
}
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
static int BoxNo = 1 ;
RegionColor[BoxNo-1] =ComboBox1->ItemIndex ;
RegionName[BoxNo-1] =Edit1->Text ;

StringGrid1->RowCount++ ;
StringGrid1->Cells[0][BoxNo] = Edit1->Text ;
StringGrid1->Cells[1][BoxNo] = "(" + IntToStr(StringGrid2->Selection.Left +1)+","+ IntToStr(StringGrid2->Selection.Top +1)+ ")" ;
StringGrid1->Cells[2][BoxNo] = "(" + IntToStr(StringGrid2->Selection.Right +1)+","+ IntToStr(StringGrid2->Selection.Bottom +1)+ ")" ;

//---bStringGrid2WаO---
for(int tmpx=StringGrid2->Selection.Left ; tmpx<=StringGrid2->Selection.Right ; tmpx++){
   for(int tmpy=StringGrid2->Selection.Top ; tmpy<=StringGrid2->Selection.Bottom ; tmpy++){
       StringGrid2->Cells[tmpx][tmpy] = StringGrid1->RowCount-1;
   }
}

BoxNo++ ;

//----------------------------
StringGrid1->Refresh();

}
//---------------------------------------------------------------------------
void __fastcall TForm1::StringGrid1DrawCell(TObject *Sender, int ACol,
      int ARow, TRect &Rect, TGridDrawState State)
{
if(ACol==0 && ARow>0){
   StringGrid1->Canvas->Brush->Color = Colors[RegionColor[ARow-1]];
   StringGrid1->Canvas->FillRect(Rect);
   StringGrid1->Canvas->TextOut(Rect.Left,Rect.Top+1,RegionName[ARow-1]);
}           
}
//---------------------------------------------------------------------------
void __fastcall TForm1::StringGrid2DrawCell(TObject *Sender, int ACol,
      int ARow, TRect &Rect, TGridDrawState State)
{
if(StringGrid2->Cells[ACol][ARow]!=""){
   StringGrid2->Canvas->Brush->Color = Colors[RegionColor[StrToInt(StringGrid2->Cells[ACol][ARow])-1]];
   StringGrid2->Canvas->Font->Color = Colors[RegionColor[StrToInt(StringGrid2->Cells[ACol][ARow])-1]];
   StringGrid2->Canvas->FillRect(Rect);
}
        
}
//---------------------------------------------------------------------------
